#include <stdio.h>
#include <stdlib.h>
#include <sys/time.h>

#define NX 10000
#define NY 10000
#define NT 10000
#define tv_to_sec(TV) (TV.tv_sec + (double)TV.tv_usec/(1000.0*1000.0))

double uold[NY+2][NX+2], unew[NY+2][NX+2];
int main(int argc, char **argv) {
  const double dthh=0.1;
  double (*u)[NX+2]=(double(*)[NX+2])(&uold[1][1]);
  double (*un)[NX+2]=(double(*)[NX+2])(&unew[1][1]);
  double (*tmp)[NX+2];
  int x, y, t;
  struct timeval tv[2];

  for (y=0; y<=NY; y++) {
    for (x=0; x<=NX; x++)  u[y][x] = un[y][x] = 0.0;
    u[y][-1] = un[y][-1] = 0.5;
  }
  for (x=-1; x<NX; x++)  u[-1][x] = un[-1][x] = 1.0;

  gettimeofday(tv, NULL);
  for (t=0; t<NT; t++) {
    double (*restrict uu)[NX+2]=u, (*restrict uun)[NX+2]=un;
    for (y=0; y<NY; y++) {
      for (x=0; x<NX; x++)
	uun[y][x] = uu[y][x] +
	  dthh*(uu[y][x-1]+uu[y][x+1]+uu[y-1][x]+uu[y+1][x]-4.0*uu[y][x]);
    }
    tmp = u;  u = un;  un = tmp;
  }
  gettimeofday(tv+1, NULL);
  printf("%f\n", tv_to_sec(tv[1])-tv_to_sec(tv[0]));

  FILE *dumpfile = fopen("diff.txt", "w");
  for (y=0; y<NY; y+=100)  for (x=-1; x<=NX; x++)
    fprintf(dumpfile, "(%4d,%4d)=%.15E\n", x, y, u[x][y]);
  fclose(dumpfile);
}
